#!/bin/env python

# pyauth.py

# Please set or add the path of the Centrify Python modules to PYTHONPATH
# in order to run this script. For example:
#
# $ export PYTHONPATH=/usr/share/centrifydc/python/lib64
#

import argparse
import pycapi
import sys

parser = argparse.ArgumentParser(description="Demo the use of the pycapi module for authentication.")
parser.add_argument("-l", "--local", action='store_true', help="authenticate local user")
parser.add_argument("name", help="user name")
parser.add_argument("password", help="user password")

args = parser.parse_args()

s = pycapi.OpenSession()
if args.local:
    type = "local"
    rc = pycapi.AuthValidatePlainTextUserNonCDC(s, args.name, args.password)
else:
    type = "AD"
    rc = pycapi.AuthValidatePlainTextUser(s, args.name, args.password)

if rc == pycapi.CDC_CODE_SUCCESS:
    print("User %s is authenticated successfully." % (args.name))
else:
    message = pycapi.GetCdcCodeStr(rc)
    print("ERROR: Cannot authenticate %s user %s: %s." %
          (type, args.name, message))    
sys.exit(rc)
