#!/bin/env python3

# Please set or add the path of the Centrify Python modules to PYTHONPATH
# in order to run this script. For example:
#
# $ export PYTHONPATH=/usr/share/centrifydc/python/lib64
#

import pylrpc;

pylrpc.createSession();
pylrpc.closeSession();

pylrpc.createSession(connectNow=True, authProcess=True);
pylrpc.closeSession();
pylrpc.createSession(authProcess=True, connectNow=True);
pylrpc.closeSession();
pylrpc.createSession(authProcess=True);
pylrpc.closeSession();
pylrpc.createSession(connectNow=True);


[print("{:17} : {}".format(key, value)) for key, value in pylrpc.adinfo().items()];

result = pylrpc.getUser("username", pylrpc.UNIX_ONLY);
if result:
    [print("{:17} : {}".format(key, value)) for key, value in result.items()];

result = pylrpc.getUser("username", 0);
if result:
    [print("{:17} : {}".format(key, value)) for key, value in result.items()];

result = pylrpc.getUser("username", pylrpc.UNIX_ONLY | pylrpc.GROUP_MEMBERSHIP);
if result:
    [print("{:17} : {}".format(key, value)) for key, value in result.items()];

result = pylrpc.getUser("username", 0);
if result:
    [print("{:17} : {}".format(key, value)) for key, value in result.items()];

print("=====================================");

result = pylrpc.getUser(999999, pylrpc.UNIX_ONLY | pylrpc.GROUP_MEMBERSHIP);
if result:
    [print("{:17} : {}".format(key, value)) for key, value in result.items()];

print("--------------------------------------");
result = pylrpc.getUser(999999, 0);
if result:
    [print("{:17} : {}".format(key, value)) for key, value in result.items()];


print("--------------------------------------");
result = pylrpc.refreshObject(type=pylrpc.UserType, name='username');
print("refresh user obj result: ", result);
result = pylrpc.refreshObject(type=pylrpc.UserType, name='non-exist');
print("refresh user obj result: ", result);

print("--------------------------------------");
result = pylrpc.refreshObject(type=pylrpc.GroupType, name='groupname');
print("refresh group obj result: ", result);
result = pylrpc.refreshObject(type=pylrpc.GroupType, name='non-exist');
print("refresh group obj result: ", result);


print("--------------------------------------");
result = pylrpc.flushCache(op=pylrpc.FLUSH_DNS_CACHE);
print("flushCache FLUSH_DNS_CACHE result: ", result);
result = pylrpc.flushCache(op=pylrpc.FLUSH_AUTH_STORE);
print("flushCache FLUSH_AUTH_STORE result: ", result);
result = pylrpc.flushCache(op=pylrpc.EXPIRE_OBJ_CACHE);
print("flushCache EXPIRE_OBJ_CACHE result: ", result);
result = pylrpc.flushCache(op=pylrpc.FLUSH_TRUSTS);
print("flushCache FLUSH_TRUSTS result: ", result);
result = pylrpc.flushCache(op=pylrpc.FLUSH_OBJ_CACHE);
print("flushCache FLUSH_OBJ_CACHE result: ", result);
result = pylrpc.flushCache(op=pylrpc.FLUSH_BINDINGS);
print("flushCache FLUSH_BINDINGS result: ", result);

pylrpc.closeSession();

